# Recombination function
recombination <- function(xh, ra, rb, rc, R) {
	##Indices
	ir.2a <- array(c(-1,1,1,-1,0,0,0,0))
	ir.2b <- array(c(0,0,0,0,-1,1,1,-1))

	ir.3a <- array(c(0,1,0,-1,0,-1,0,1))
	ir.3b <- array(c(-1,0,1,0,1,0,-1,0))
	
	ir.4a <- array(c(-1,1,0,0,1,-1,0,0))
	ir.4b <- array(c(0,0,1,-1,0,0,-1,1))

	ir.5a <- array(c(0,1,-1,0,0,-1,1,0))
	ir.5b <- array(c(-1,0,0,1,1,0,0,-1))
	
	ir.6a <- array(c(1,0,-1,0,0,-1,0,1))
	ir.6b <- array(c(0,1,0,-1,-1,0,1,0))
	
	ir.7a <- array(c(1,0,0,-1,-1,0,0,1))
	ir.7b <- array(c(0,-1,1,0,0,1,-1,0))
	
	D <- function(x1, x2, x3, x4) {
		xh[x1]*xh[x2] - xh[x3]*xh[x4]
	}	
	
	xh <- (xh 	+ ir.2a*ra*D(1,4,2,3)
				+ ir.2b*rc*D(5,8,6,7)
				+ ir.3a*(rb + R - 2*rb*R)*D(4,6,2,8)
				+ ir.3b*(rb + R - 2*rb*R)*D(1,7,3,5)
				+ ir.4a*R*D(1,6,2,5)
				+ ir.4b*R*D(4,7,3,8)
				+ ir.5a*(R - rb*R)*D(3,6,2,7)
				+ ir.5b*(R - rb*R)*D(1,8,4,5)
				+ ir.6a*rb*D(3,6,1,8) 
				+ ir.6b*rb*D(4,5,2,7) 
				+ ir.7a*rb*R*D(2,7,3,6) 
				+ ir.7b*rb*R*D(4,5,1,8))
	xh
}

