# Parameters - Set for all runs
x <- runif(1)
f.A <- c(x,1-x) #Initial frequency of host-allele (this is redone in each burn-in replicate in the procedure "do.one.rep")
f.B <- c(0, 1)
f.M <- c(0, 1)
mu.h <- 1e-3 #mutation rate in host
mu.p <- 1e-3 #mutation rate in parasite
R <- 0.01 #recombination rate between modifier and B locus

# Parameters - If not using a script, set parameters of interest here: 
num <- 10000 #population size
alpha.p <- 0.1
alpha.h <- -0.1
beta <- 0.1
ra <- 0.02
rb <- 0.01
rc <- 0.0
when.intro <- 1250

